program TimerCall;
{
  A demonstration of how to write a timer call back function.

  This program comes with no guarrentees and no support.
}



uses Strings, WinTypes, WinProcs, OWindows;
const
  wm_PaintIt= wm_User;

type
  PStepWindow = ^TStepWIndow;
  TStepWindow = object(TWindow)
    DragDC: HDC;
    HasChanged: Boolean;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure SetUpWindow; virtual;
    procedure PaintIt(var Msg: TMessage);
      virtual wm_First + wm_PaintIt;
  end;

  TMyApplication = object(TApplication)
    procedure InitMainWindow; virtual;
  end;

constructor TStepWindow.Init(AParent: PWindowsObject; ATitle: PChar);
begin
  TWindow.Init(AParent, ATitle);
  HasChanged := False;
end;

function TimerCallBack(HWindow: HWnd; Msg: Word; WParam: Word; LParam: LongInt): Word; export;
begin
  SendMessage(HWindow, wm_PaintIt, 0, 0);
end;

procedure TStepWindow.SetUpWindow;
var
  TimerProc: TFarProc;
begin
  TWindow.SetUpWindow;
  TimerProc := MakeProcInstance(@TimerCallBack, HInstance);
  SetTimer(HWindow, 1, 1000, TimerProc);
end;

procedure TStepWindow.PaintIt(var Msg: TMessage);
var
  ADC: HDC;
  TheBrush: HBrush;
  R:TRect;
begin
  ADC := GetDC(HWindow);
  GetClientRect(HWindow, R);
  TheBrush := CreateSolidBrush(Rgb(Random(255),Random(255), Random(255)));
  FillRect(ADC, R, TheBrush);
  ReleaseDC(HWindow, ADC);
  DeleteObject(TheBrush);
end;

procedure TMyApplication.InitMainWindow;
begin
  MainWindow := New(PStepWindow, Init(nil, 'Steps'));
end;

var
  MyApp: TMyApplication;

begin
  MyApp.Init('Steps');
  MyApp.Run;
  MyApp.Done;
end.